use thiserror;

use crate::pe_parse::error::{self, PEParseError};

#[derive(Debug, thiserror::Error)]
pub enum AppError {
    #[error(transparent)]
    Io(#[from] std::io::Error),

    // 未打开文件映射
    #[error("文件未打开!")]
    NoFileOpened,

    #[error(transparent)]
    PeParseError(#[from] PEParseError),
}

impl serde::Serialize for AppError {
    fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
    where
        S: serde::ser::Serializer,
    {
        serializer.serialize_str(self.to_string().as_ref())
    }
}
