use thiserror::Error;

#[derive(Error, Debug)]
pub enum PEParseError {
    #[error("无效的DOSMagic值")]
    InvalidDOSMagic,
    #[error("Invalid NT header signature")]
    InvalidNTSignature,
    #[error("Invalid optional header magic number")]
    InvalidOptionalMagic,
    #[error("Invalid optional header size")]
    InvalidOptionalSize,
    #[error("解析超出了文件范围")]
    OutOfBounds,
}
